Bug 853953 - xdelta 3.0.0-3.fc17 stack overflow
xdelta 3.0.0-3.fc17 stack overflow
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: xdelta (Show other bugs)
17
i686 Linux
unspecified Severity unspecified
: ---
: ---
Assigned To: Adam Tkac
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-09-03 07:59 EDT by Sandro Bonazzola
Modified: 2013-04-30 19:52 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-09-17 13:32:51 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Sandro Bonazzola 2012-09-03 07:59:11 EDT
Stack overflaw executing xdelta between files > 3Gb.
xdelta 3.0.4 is out, maybe just bump to the latest released xdelta could solve this.


*** buffer overflow detected ***: /usr/bin/xdelta terminated
======= Backtrace: =========
/lib/libc.so.6(__fortify_fail+0x45)[0x4381eb85]
/lib/libc.so.6[0x4381cbda]
/lib/libc.so.6[0x4381c2a8]
/lib/libc.so.6(_IO_default_xsputn+0x14e)[0x4378409e]
/lib/libc.so.6(_IO_vfprintf+0x3c7f)[0x43758c8f]
/lib/libc.so.6(__vsprintf_chk+0xcc)[0x4381c37c]
/lib/libc.so.6(__sprintf_chk+0x2f)[0x4381c28f]
/usr/bin/xdelta[0x805e042]
/usr/bin/xdelta[0x805e839]
/usr/bin/xdelta[0x804bca9]
/lib/libc.so.6(__libc_start_main+0xf5)[0x4372b635]
/usr/bin/xdelta[0x804be25]
======= Memory map: ========
08048000-0806c000 r-xp 00000000 fd:01 1986323    /usr/bin/xdelta3
0806c000-0806d000 rw-p 00024000 fd:01 1986323    /usr/bin/xdelta3
0806d000-08098000 rw-p 00000000 00:00 0          [heap]
436eb000-4370a000 r-xp 00000000 fd:01 1972766    /usr/lib/ld-2.15.so
4370a000-4370b000 r--p 0001e000 fd:01 1972766    /usr/lib/ld-2.15.so
4370b000-4370c000 rw-p 0001f000 fd:01 1972766    /usr/lib/ld-2.15.so
43712000-438bd000 r-xp 00000000 fd:01 1974335    /usr/lib/libc-2.15.so
438bd000-438be000 ---p 001ab000 fd:01 1974335    /usr/lib/libc-2.15.so
438be000-438c0000 r--p 001ab000 fd:01 1974335    /usr/lib/libc-2.15.so
438c0000-438c1000 rw-p 001ad000 fd:01 1974335    /usr/lib/libc-2.15.so
438c1000-438c4000 rw-p 00000000 00:00 0 
438c6000-438ef000 r-xp 00000000 fd:01 1987118    /usr/lib/libm-2.15.so
438ef000-438f0000 r--p 00028000 fd:01 1987118    /usr/lib/libm-2.15.so
438f0000-438f1000 rw-p 00029000 fd:01 1987118    /usr/lib/libm-2.15.so
43aa2000-43abe000 r-xp 00000000 fd:01 1988601    /usr/lib/libgcc_s-4.7.0-20120507.so.1
43abe000-43abf000 rw-p 0001b000 fd:01 1988601    /usr/lib/libgcc_s-4.7.0-20120507.so.1
b37dc000-b7fdf000 rw-p 00000000 00:00 0 
b7ffd000-b7fff000 rw-p 00000000 00:00 0 
b7fff000-b8000000 r-xp 00000000 00:00 0          [vdso]
bffdf000-c0000000 rw-p 00000000 00:00 0          [stack]

Program received signal SIGABRT, Aborted.
0xb7fff424 in __kernel_vsyscall ()
Missing separate debuginfos, use: debuginfo-install libgcc-4.7.0-5.fc17.i686
(gdb) bt
#0  0xb7fff424 in __kernel_vsyscall ()
#1  0x4374093f in __GI_raise (sig=sig@entry=6) at ../nptl/sysdeps/unix/sysv/linux/raise.c:64
#2  0x43742293 in __GI_abort () at abort.c:91
#3  0x4377ff65 in __libc_message (do_abort=do_abort@entry=2, fmt=fmt@entry=0x43880be9 "*** %s ***: %s terminated\n") at ../sysdeps/unix/sysv/linux/libc_fatal.c:198
#4  0x4381eb85 in __GI___fortify_fail (msg=msg@entry=0x43880b8f "buffer overflow detected") at fortify_fail.c:32
#5  0x4381cbda in __GI___chk_fail () at chk_fail.c:29
#6  0x4381c2a8 in _IO_str_chk_overflow (fp=0xbfffe000, c=56) at vsprintf_chk.c:35
#7  0x4378409e in _IO_default_xsputn (f=0xbfffe000, data=0xbfffdfb6, n=10) at genops.c:485
#8  0x43758c8f in _IO_vfprintf_internal (s=s@entry=0xbfffe000, format=<optimized out>, format@entry=0x8064afe "source size %s [%llu]", ap=0xbfffe10c "ͮxC\364\377\213C", ap@entry=0xbfffe100 "\340\307\006\b") at vfprintf.c:1575
#9  0x4381c37c in ___vsprintf_chk (s=s@entry=0x806c800 "source size 3.03 GiB [325375180", flags=flags@entry=1, slen=slen@entry=32, format=format@entry=0x8064afe "source size %s [%llu]", args=args@entry=0xbfffe100 "\340\307\006\b")
    at vsprintf_chk.c:87
#10 0x4381c28f in ___sprintf_chk (s=s@entry=0x806c800 "source size 3.03 GiB [325375180", flags=flags@entry=1, slen=slen@entry=32, format=format@entry=0x8064afe "source size %s [%llu]") at sprintf_chk.c:33
#11 0x0805e042 in sprintf (__fmt=0x8064afe "source size %s [%llu]", __s=0x806c800 "source size 3.03 GiB [325375180") at /usr/include/bits/stdio2.h:34
#12 main_set_source (stream=stream@entry=0xbfffe594, sfile=sfile@entry=0xbfffe9f4, source=source@entry=0xbfffe284, cmd=<optimized out>) at xdelta3-blkcache.h:244
#13 0x0805e839 in main_input (cmd=cmd@entry=CMD_ENCODE, ifile=ifile@entry=0xbfffe974, ofile=ofile@entry=0xbfffe9b4, sfile=sfile@entry=0xbfffe9f4) at xdelta3-main.h:3161
#14 0x0804bca9 in main (argc=2, argv=0xbfffee9c) at xdelta3-main.h:3935
Comment 1 Adam Tkac 2012-09-04 13:26:53 EDT
(In reply to comment #0)
> Stack overflaw executing xdelta between files > 3Gb.
> xdelta 3.0.4 is out, maybe just bump to the latest released xdelta could
> solve this.

You are probably right, changelog contains some changes related to big files.
Comment 2 Fedora Update System 2012-09-04 13:50:33 EDT
xdelta-3.0.4-1.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/xdelta-3.0.4-1.fc18
Comment 3 Fedora Update System 2012-09-04 13:50:44 EDT
xdelta-3.0.4-1.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/xdelta-3.0.4-1.fc17
Comment 4 Fedora Update System 2012-09-04 18:57:14 EDT
Package xdelta-3.0.4-1.fc17:
* should fix your issue,
* was pushed to the Fedora 17 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing xdelta-3.0.4-1.fc17'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2012-13336/xdelta-3.0.4-1.fc17
then log in and leave karma (feedback).
Comment 5 Sandro Bonazzola 2012-09-05 09:36:01 EDT
(In reply to comment #3)
> xdelta-3.0.4-1.fc17 has been submitted as an update for Fedora 17.
> https://admin.fedoraproject.org/updates/xdelta-3.0.4-1.fc17

This works fine for me.
Comment 6 Fedora Update System 2012-09-17 13:32:51 EDT
xdelta-3.0.4-1.fc17 has been pushed to the Fedora 17 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 7 Fedora Update System 2012-09-17 20:05:39 EDT
xdelta-3.0.4-1.fc18 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.